
#define VERSION "161219"

#define DIRECTORY  "C:\_MikroC\_MesProjets_MikroC\_Max7219_4_matrice8x8"
#define PROJECT "18F46K22_MAX7219_4x_Matrice8x8.mcppi"
#define SOURCE "18F46K22_test_Max71219_4xMatrice8x8_SOFT_SPI"
#define EEPROM  "18F46K22_MAX7219_4x_Mat_8x8_SPI1_Softw_EEPROM.ihex"

#define PROCESSOR "18F46K22"
#define POWER_SUPPLY 5V

#define FOSC_INTERNE
#define FOSC 8.0  //8 MHz
#define BAUD 19200  // UART1
#define Langage  Mikroc V 6.6.3
#define Timer1_LOW
#define SOFTWARE_SPI1
//#define HARDWARE_SPI1
// #define DEBUGGING

//HARDWARE module

 #define With_UART1
// UART RC6 =TX=fil blanc   RC7= RX=fil vert  Interface Prolific LTTL/USB  -> COM12 19200  -> PC XP  VBray 2014
// librairies utilises:
// UART , C_String   C_Stdlib   Conversions , I2C
// EEPROM :

/* Config bit  :
C:\_MikroC\_MesProjets_MikroC\_Max7219_4_matrice8x8\18F46K22_FOSC_Interne_8MHz
CONFIG1H : $300001 : 0x0028
CONFIG2L : $300002 : 0x001E
CONFIG2H : $300003 : 0x003C
CONFIG3H : $300005 : 0x0098
CONFIG4L : $300006 : 0x0080
CONFIG5L : $300008 : 0x000F
CONFIG5H : $300009 : 0x00C0
CONFIG6L : $30000A : 0x000F
CONFIG6H : $30000B : 0x00E0
CONFIG7L : $30000C : 0x000F
CONFIG7H : $30000D : 0x0040


  // ac:pinout_18f46k22
  
 //   ac:Max7219_DS
 
 // ac:P18F46K22_SPI_link
   

 Miniinthebox 5281696500001
MAX7219 matricielle 8 * 8 en srie interfac huit chiffres a conduit pilote d'affichage pour Arduino
 #02816965   3.91 euros
 Disolay Leds 8x8 1088AS

 hardware
I2C2      SCL2 sur RD0   Pin 19
I2C2      SDA2 sur RD1   Pin 20

I2C1      SCL1 sur RC3   pin 18    si LCD2119
I2C1      SDA1 sur RC4   pin 23    si LCD2119

+5V                               ------- Pin 1  MAX7219 #1 Module 8x8 -  MAX7219 #2- -- MAX7219 #3---- MAX7219 #4
0V Gnd                            ------- Pin 2  MAX7219 #1 Module 8x8 -  MAX7219 #2- -- MAX7219 #3---- MAX7219 #4
SPI1      SDO      RC5   pin 24   ------- Pin 3  MAX7219 #1 Module 8x8 -  MAX7219 #2- -- MAX7219 #3---- MAX7219 #4
SPI1      SDIN     RC4   pin 23   not used
Select             RC0   pin 15   ------- Pin 4  MAX7219 #1 Module 8x8 -  MAX7219 #2- -- MAX7219 #3---- MAX7219 #4
SPI1      CLCK     RC3   pin 18   ------- Pin 5  MAX7219 #1 Module 8x8 -  MAX7219 #2- -- MAX7219 #3---- MAX7219 #4

UART1 TX  sur RC6        pin 25
UART1 RX  sur RC7        pin 26

UART2 TX  sur ED6        pin 29
UART2 RX  sur RD7        pin 30
RA0       Entree Analog  pin 2

*/

#include "built_in.h"     // for  Hi  Lo ..etc


#define CLS 12
#define CR 13
#define LF 10
#define TAB 9
#define BACK 8
#define Separator 0x20   // space

#define NbCycles_T1 8       // nb d'interrupot pour faire 1 seconde

sbit Led_Rouge at LATA5_bit;
sbit Led_Rouge_Direction  at TRISA5_bit;
//it Test_Freq at PORTC2_bit;
//


sbit  SPI_CS   at LATC0_bit;
sbit  SPI_CS_direction   at TRISC0_bit;
/* SPI bit bang
sbit  SPI_clk  at LATC3_bit;
sbit  SPI_Out at LATC5_bit;
sbit  SPI_clk_direction  at TRISC3_bit;
sbit  SPI_Out_direction  at TRISC5_bit;
*/

// Software SPI module connections
sbit SoftSpi_SDI at RC4_bit;
sbit SoftSpi_SDO at RC5_bit;
sbit SoftSpi_CLK at RC3_bit;

sbit SoftSpi_SDI_Direction at TRISC4_bit;
sbit SoftSpi_SDO_Direction at TRISC5_bit;
sbit SoftSpi_CLK_Direction at TRISC3_bit;

const code char mesg0[]=" Mikroc 6.63 "PROCESSOR" \n\r";
const code char mesg1[]=" Directory : "DIRECTORY" \n\r";
const code char mesg2[]=" Projet : "PROJECT"r\n";
const code char mesg3[]=" Source : "SOURCE"_"VERSION".c \r\n";
const code char mesg4[]=" Module Matrice 8x8 avec MAX7129\n\r";
const code char mesg5[]=" Saisir un nouveau Msg avec le terminal via <Msg=xxxx>\r\n";
const code char mesg6[]=" Mode Temperature avec <TEMP_ON> ou <TEMP_OFF>\r\n";
const code char mesg7[]= "Messages en EEPROM avec cde : <EEPROM=0> ..  15 \r\n";
const code char mesg8[]= "*JOYEUX NOEL*";
const code char mesg9[]=" xxxxxx ";

const code char * Messages[]={mesg0,mesg1,mesg2,mesg3,mesg4,mesg5,mesg6,mesg7,mesg8,mesg9};

#define MAXLEN1 128
volatile unsigned char buffer1[MAXLEN1];
volatile int Flag_Buffer1;
volatile  unsigned char c1;
volatile unsigned int i1;
volatile int Index1;
volatile unsigned int CptErr;


static int Flag_Timer1;
static unsigned int Cpt1;
static unsigned int Max_Timer1;


int i,j,k,l,m,n;
unsigned  char TEXTE[80]; // pour teste quelconque
unsigned char TEXTE2[80]; // pour temperature Amb
unsigned char * txt;
unsigned char * txt2;
unsigned char *p;

char CRam1[32];   // for flot2asccii use
char Tampon[35];
unsigned int EAnx,EAn0,EAn1;
unsigned int SEAn0,SEAn1;
int nM;
unsigned char N1;
unsigned char  addr,donnee;
unsigned int Etat;
unsigned int clk;
unsigned long OverFlow_Timer0;
unsigned long L1,L2;
unsigned char Compteur;

float f1,f2,ff;


// MAX7129 matrice 8x8
unsigned char Aff_buffer[65];  //  8*8=64 + eventuell string terminator=0
unsigned Display_32x8_Pixel[256];
unsigned int Speed=100;

volatile struct chbits {   // 8 flags
     unsigned FrameErr:1;
     unsigned Over:1;
     unsigned Dialogue:1;
     unsigned FLT:1;
     unsigned PPS:1;
     unsigned Temper:1;
     unsigned Elapsed_Time:1;
     unsigned Mesure:1;
     unsigned First_Run:1;
   }Drapeaux ;

// ---------------------------------------

void Init_Hardware(void) ;
void Read_Msg_Eeprom( int depuis);
void Write_Msg_Eeprom( int Adr,const char * d1) ;

void Init_Timer1 (void);  //  timer 100mS * Max_timer1
void Arme_Timer1(void);   //
void Init_Timer0 (void);  //  counter in RA4 input
void strConstRamCpy(unsigned char *dest, const code char *source);
void UART1_Write_CText(const char *txt);
void RAZ_UART1(void);
unsigned char *Float2Ascii (float x, unsigned char *chaine,char precision) ;
void CRLF1(void)  ;
void Read_Msg64_Eeprom( unsigned char * T,int depuis);


void Interrupt_High() iv 0x0008 ics ICS_AUTO
{
 if ( (RCIE_bit) && ( RCIF_bit))
   {
   // traitement separe des erreurs de COM
      c1 = RCREG;
      if (RCSTA.OERR==1)    // voir parag 16.1.26 p273
      {
       RCSTA.CREN = 0 ;
       c1 = RCREG;
       RCSTA.CREN = 1 ;
        CptErr++;

       }
      if(RCSTA.FERR==1 )
      {
      RCSTA.SPEN = 0 ;
      RCSTA.SPEN= 1 ;
      CptErr++;
       c1 = RCREG;
      }
     if ((c1==CR) || (i1 > MAXLEN1-2))
      {
      Flag_Buffer1=1;
      PIE1.RCIE=0 ; //interdit IT Reception UART
      buffer1[i1]=0;
      Index1=i1;
      i1=0;
      c1=0;
     }
     else
     {
        if (i1 > MAXLEN1-2)  Flag_Buffer1=2;
        buffer1[i1]=c1;
        Index1=i1;
        i1++;

      }
   }
    // comptage depassement Timer0
     if ((TMR0IE_bit) && (TMR0IF_bit) )
      {     TXREG1='*';
           OverFlow_Timer0++;
            TMR0IF_bit = 0;
       }
     // -----  timer 1  ----------------
  #ifndef Timer1_LOW
   if  ( (TMR1IE_bit==1) && ( TMR1IF_bit==1))
   {  // Test "Peripheral Interrupt Request Register 1" for Timer1 Flag
     Cpt1++;
     //TXREG1='#';
     if (Cpt1 >=Max_Timer1)   // x100 ms
       {
        TMR1IE_bit=0; // stop comptage  timer1
        TMR1ON_bit=0;
        Cpt1=0;
        Flag_Timer1=1;
        TMR1ON_bit=0;
        TMR1IE_bit=0;
      }
      TMR1H= 0x0B; // Hi (3035);
      TMR1L= 0xDB; // Lo (3035);
      PIR1.TMR1IF=0;
   }
   #endif
 }

#ifdef Timer1_LOW
void Interrupt_LOW() iv 0x0018 ics ICS_AUTO
 {

  // -----  timer 1  ----------------
  if  ( (TMR1IE_bit==1) && ( TMR1IF_bit==1))
   {  // Test "Peripheral Interrupt Request Register 1" for Timer1 Flag
     Cpt1++;
     //TXREG1='#';
     if (Cpt1 >=Max_Timer1)   // x100 ms
       {
        TMR1IE_bit=0; // stop comptage  timer0
        Cpt1=0;
        Flag_Timer1=1;
        TMR1ON_bit=0;
        TMR1IE_bit=0;
      }
      TMR1H= 0x0B; // Hi (3035);
      TMR1L= 0xDB; // Lo (3035);
      PIR1.TMR1IF=0;
   }
 }
 #endif




 void Read_Msg64_Eeprom(unsigned char *T, int debut)
{   int i1 ,i;
  i1=0;
  do
  {
  i = EEPROM_Read(i1+debut);
  if ( i==0) break;
  if ( i1>63) break;
  //UART1_Write(i);
  *(T+i1)=i;
  Delay_ms(1);
  i1++;
   }
  while (i!=0) ;
  *(T+i1-1)=0;
 }


// --- Copie le texte depuis FLASH ROM vers RAM
void strConstRamCpy(unsigned char *dest, const code char *source)
 {
  while (*source)*dest++ = *source++ ;
  *dest = 0 ;    // terminateur
}

void CRLF1()
{
 UART1_Write(CR);
 UART1_Write(LF);
}

void UART1_Write_CText(const char *txt)
 {
   while (*txt)
      UART1_Write(*txt++);
}

/*

void Write_Msg_Eeprom(int Adr,const char * d1)
{ int i1 ,i;
  char c1;
  i1=Adr;
  do
  {
  c1=*d1;
  EEPROM_Write(Adr,c1);
  if ( c1==0) break;
  if ( i1>1023) break;
  Delay_ms(5);
  i1++;
  }
  while (i!=0) ;
 }


void Read_Msg_Eeprom( int debut)
{   int i1 ,i;
  i1=debut;
  do
  {
  i = EEPROM_Read(i1);
  if ( i==0) break;
  if ( i1>1023) break;
  UART1_Write(i);
  Tampon[i1-debut]=i;
  Delay_ms(5);
  i1++;
   }
  while (i!=0) ;
 }
*/

void Float2Ascii (float x, unsigned char *str,char precision)
{
 /* converts a floating point number to an ascii string */
 /* x is stored into str, which should be at least 30 chars long */
 int ie, i, k, ndig;
 double y;
 ndig = ( precision<=0) ? 7 : (precision > 22 ? 23 : precision+1);
 ie = 0;
 /* if x negative, write minus and reverse */
 if ( x < 0)
 {
   *str++ = '-';
   x = -x;
 }
 /* put x in range 1 <= x < 10 */
 if (x > 0.0) while (x < 1.0)
 {
   x *= 10.0;                // a la place de =*
   ie--;
 }
 while (x >= 10.0)
 {
   x = x/10.0;
   ie++;
 }
 // in f format, number of digits is related to size
 ndig += ie;                                // a la place de =+
 //round. x is between 1 and 10 and ndig will be printed to
 // right of decimal point so rounding is ...
 for (y = i = 1; i < ndig; i++)
 y = y/10.;
 x += y/2.;
 if (x >= 10.0) {x = 1.0; ie++;}
 if (ie<0)
 {
   *str++ = '0'; *str++ = '.';
   if (ndig < 0) ie = ie-ndig;
   for (i = -1; i > ie; i--)  *str++ = '0';
 }
 for (i=0; i < ndig; i++)
 {
   k = x;
   *str++ = k + '0';
   if (i ==  ie ) *str++ = '.';
   x -= (y=k);
   x *= 10.0;
  }
 *str = '\0';
}


 void Init_Hardware()
{
  PORTA = 0b00010011;
  ANSELA=0;
  ANSELA.ANSA0=1;    //  analog input on Port A   voir page 154
  ANSELA.ANSA1=1;
  TRISA = 0b00010111 ;   // PORTA is RA0,1= analog input  RA2=sortie DAC RA3  RA4=Input  RA5,6=Digital output
  Led_Rouge_Direction=0;
  Led_Rouge=0;
  PORTA=0;
  CCP5CON=0;


  PORTB = 0xFF;
  TRISB = 0x83;    //  B0,B1 as input   ATTENTION B7 B6 for ICSP Pickit3
  ANSELB=0;

  PORTC = 0x00;          // RC0..RC5,RC7 = input RC6=Output
  ANSELC=0;
  TRISC = 0xFF;    //
  TRISC.TRISC7 = 1;  // RX - UART1
  TRISC.TRISC6 = 0;  // TX - UART1
  
  // specific SPI bit bang
  SPI_CS_direction=0;
  SPI_CS=1;
 /*
  SPI_clk_direction=0;
  SPI_Out_direction=0;
  SPI_clk=0;
  SPI_Out=0;
 */

  PORTD=0;
  ANSELD=0;
  TRISD=0xFF;
  TRISD.TRISD0 = 0;  // SCL I2C2
  TRISC.TRISD1 = 1;  // SDA I2C2
  TRISD.TRISD6 = 0;  // TX UART2
  TRISC.TRISD7 = 1;  // RX UART2

  SLRCON=0; // standard rate for PORTA,B,C,D,E
 }

void Init_ADC()
 {
       //config lecture ADC 10 bits
 ADCON0.ADON=1;      // ADC enabled chanel 0
 ADCON1.TRIGSEL=0 ; // trigger from CCP5
 ADCON2.ADFM=1;     // right justified
 ADCON2.ACQT2=1;
 ADCON2.ACQT1=1;
 ADCON2.ACQT0=0;    // 16 TAD
 ADCON2.ADCS1=1;    // select RA0 = analog input
 ADCON2.ADCS2=0;    // RA1 = Analog input
 ADCON2.ADCS0=0;    // Fosc/32
 ADCON1.PVCFG1=0;   // +Vref = +5V AVdd
 ADCON1.PVCFG0=0;
 ADCON1.NVCFG1=0;   // -Vref = Gnd AVss
 ADCON1.NVCFG0=0;
 }

void RAZ_UART1()
{
    for (i1=0;i1<MAXLEN1;i1++) buffer1[i1]=0;
    i1=0;
    Index1=0;
    c1=RC1REG;
    c1=0;
    Flag_Buffer1 =0;
    RC1IE_bit = 1;
}


void Init_Timer0(void)
{
   // init en compteur sur entree RA4
  T08BIT_bit=0; // mode 16 bits
  T0CS_bit=1;  // mode comptage sur pin T0CKI= RA4
  T0SE_bit=1; // front edge
  PSA_bit=1; //  1= Not use of prescaler => 1/1 , because, if used prescaler minimum is 1/2
  T0PS2_bit=0; // prescaler 1/2
  T0PS1_bit=0;
  T0PS0_bit=0;
  TMR0H = 0;
  TMR0L = 0;
  TMR0IP_bit=1;   // high priority
  TMR0IF_bit=0;
  TMR0IE_bit=1;
  OverFlow_Timer0=0;
  TMR0ON_bit=1;
}

void Arme_Timer1(void)
{
   // 100mS * Max_Timer1
  TMR1IF_bit         = 0;
  TMR1H         = 0x0B;
  TMR1L         = 0xDC;
  Cpt1=0;
  Flag_Timer1=0;
  TMR1ON_bit=1;     // Timer0 ON
  TMR1IE_bit= 1;
  }


void Init_Timer1(void)
 {
//FOSC=16Mhz  Prescaler 1:8; TMR1 Preload = 3035; Actual Interrupt Time : 125 ms
  T1CON         = 0x00;
  TMR1CS1_bit=0; // FOSC/4
  TMR1CS0_bit=0;
  T1RD16_bit=1;
  T1CKPS1_bit=1;  //Prescaler 1:8
  T1CKPS0_bit=1;
  TMR1H  = 0x0B;
  TMR1L  = 0xDC;
   TMR1IF_bit  = 0;
  #ifdef Timer1_LOW
  TMR1IP_bit=0;   // low level interrupt
  #else
  TMR1IP_bit=1;   // low level interrupt
  #endif
  Cpt1=0;
  Flag_Timer1=0;
  TMR1ON_bit=0;
  TMR1IE_bit =0;
}

 #include "SPI_MAX7219_4_Matrice_8x8.inc"
 /*
 void SPI_Write_To_7219(unsigned char adr, unsigned char d1, unsigned char d2);
 void Clear_Matrice(void) ;
 void Affiche_Char(unsigned char c, unsigned int v);
 void Init_Module_Max7129_8x8(void);
 void Affiche_Text_Matrice(unsigned char *p, unsigned int V);
 void Affiche_CText_Matrice(const unsigned char *p, unsigned int V);
*/

void main()
{

  #ifdef FOSC_INTERNE
  //OSCCON = 0b01110010  ; //0x72 ;     //Oscillateur  16Mhz
  OSCCON = 0b01100010  ; //0x62 ;     //Oscillateur  8Mhz
  //OSCTUNE.PLLEN=1
  OSCTUNE=0;
  OSCTUNE.PLLEN=0;
  OSCCON2=0;
  //while (OSCCON.HFIOFS==0); // wait stable oscillator
  #else
  // Q=20Mhz
  #endif
   Delay_ms(1000);

  Init_Hardware() ;
  SPI_CS=1;
  Max_Timer1=8;
  Led_Rouge=0;

  UART1_Init(19200);
  Delay_ms(100);
  UART1_Write(CLS);   // Erase screen terminal  :it is an option on Vbray Terminal!
  Delay_ms(500);

  txt=&TEXTE[0];
  txt2=&TEXTE2[0];
  
   CRLF1();
  // presentation sur UART1
  UART1_Write_CText ("Presentation : \r\n");
  for(i=0;i<8;i++)
  {
  
    UART1_Write_CText(Messages[i]);
   }
  Delay_ms(2000);
  CRLF1();
  clk = Clock_kHz();
  strConstRamCpy(txt,"\r\nClock initiale in  =  ...  Khz \r\n");
  WordToStr(clk,CRam1);
  memcpy(txt+ 23,CRam1,5);
  UART1_Write_Text(txt);

  //RC1IE_bit=1 ;
  //RC1IP_bit=1;
  #ifdef Timer1_LOW
  TMR1IP_bit=0;   // low level interrupt
  #else
  TMR1IP_bit=1;   // low level interrupt
  #endif

   UART1_Write_CText("init ADC EA0 \r\n" )  ;
   Init_ADC();
   
   UART1_Write_CText("init SOFT SPI  RC3=Clk ,RC5=Dout  RC0=CS -> MAx7219:\r\n" )  ;
   Soft_SPI_Init();
   Init_Module_4_Max7129_8x8();
   UART1_Write_CText("Clear Matrice 2x 8x8\r\n" )  ;
   Clear_Matrices() ;

   PEIE_bit=1;
   RCON.IPEN = 1;       // enable priority levels  , car TMR1 => low interrupt
   PEIE_bit = 1;          // Enable Peripheral interrupt
   GIE_bit  = 1;         // Enable Global interrupt
   
   UART1_Write_CText("Init et test interrupt Timer1  8 x 125 msec soit 2 sec \r\n" );
   Max_Timer1=8;
   Init_Timer1();
   Arme_Timer1();
   TXREG1='$';
   CRLF1();
   while(Flag_Timer1==0);
   TXREG1='#';
   CRLF1();
  
    UART1_Write_CText("Display <0123456789> sur matrices Leds \r\n");
    Clear_Matrices() ;
    Affiche_CText_Matrice("    ",1);
    Affiche_CText_Matrice("0123456789", 25);
    Led_Rouge=~Led_Rouge;
    Delay_ms(2000);
    Led_Rouge=~Led_Rouge;
    
     ///  Affiche temperature ambiante   sur terminal only !
     UART1_Write_CText("Display <J=   0  TAMB= 48.3 C> sur matrices Leds\r\n");
     Clear_Matrices() ;
     Affiche_CText_Matrice("    ", 1);
     strConstRamCpy(txt2,"J= ");
     k=strlen(txt2);
     ByteToStr(Compteur,CRam1);
     strcat(txt2+k,CRam1); // 3 digits utiles
     k=strlen(txt2);
     strConstRamCpy(txt2+k," TAMB= ");
     k=ADC_Read(0);
     f1=(float)k*50.0/1024.0;
     Float2Ascii (f1,CRam1,1);
      k=strlen(txt2);
     strcat(txt2+k,CRam1);
     k=strlen(txt2);
     strConstRamCpy(txt2+k,"C");
     UART1_Write_Text(txt2);  CRLF1();
      k=strlen(txt2);
     Led_Rouge=~Led_Rouge;
      for(i=0;i<k;i++)
      {
       if (*(txt2+i)=='')*(txt2+i)=126;  // char   de  la table Ascii_8x8[1024]
     }
     txt2=&TEXTE2[0];
     Affiche_Text_Matrice(txt2, 80);
     Delay_ms(2000);
     
     

  UART1_Write_CText("Affiche Messages 0  15  stockes en EEPROM du PIC18F \r\n" )   ;
  for (i=0;i<15;i++)
  {
  k=i<<6;
  Read_Msg64_Eeprom(txt,k);
  UART1_Write_CText("Eeprom # ");
  WordToHex(k,CRam1);UART1_Write_Text(CRam1);UART1_Write(TAB);
  UART1_Write_Text(txt);    CRLF1();
  Affiche_Text_Matrice(txt, 25);
   }

         // affiche  Joeux noel  par defaut
     Clear_Matrices() ;
     Affiche_CText_Matrice("    ", 1);
     txt=&TEXTE[0];
     strConstRamCpy(txt,Messages[8]);
     UART1_Write_CText("Message 8 : ");
     UART1_Write_Text(txt);  CRLF1();
     k=strlen(txt); // => 24
     for(i=0;i<k;i++)
     {
       if (*(txt+i)=='')*(txt+i)=126;  // char   de  la table Ascii_8x8[1024]
     }
     txt=&TEXTE[0];
     Affiche_Text_Matrice(txt, 80);
     Delay_ms(2000);

    Drapeaux.Temper=0 ;
    Compteur=0;
    Speed=80;
    RAZ_UART1();  // init Interrupt UART1
    
    while (1)
    {
     Clear_Matrices() ;
     Affiche_CText_Matrice("    ", 1);

    // affichage Temperature ambiante
     if (Drapeaux.Temper==1)
     {
     strConstRamCpy(txt2,"J= ");
     k=strlen(txt2);
     ByteToStr(Compteur,CRam1);
     strcat(txt2+k,CRam1); // 3 digits utiles
     UART1_Write_Text(txt2)  ;
     UART1_Write(TAB);

      txt2=&TEXTE2[0];
     strConstRamCpy(txt2,"T.Amb=");
     k=ADC_Read(0);
     f1=(float)k*50.0/1024.0;
     Float2Ascii (f1,CRam1,1);
     k=strlen(txt2);
     strcat(txt2+k,CRam1);
      k=strlen(txt2);
     strConstRamCpy(txt2+k,"C");
     UART1_Write_Text(txt2);  CRLF1();
     k=strlen(txt2);
     for(i=0;i<k;i++)  if(*(txt2+i)=='') *(txt2+i)=126;
     Affiche_Text_Matrice(txt2, Speed);
     }
     else
     {
      txt=&TEXTE[0];
      UART1_Write_Text(txt);  CRLF1();
      for(i=0;i<strlen(txt);i++)  if(*(txt+i)=='') *(txt+i)=126;
      Affiche_Text_Matrice(txt, Speed);
     }
     Delay_ms(1000);

     Compteur++;
     

    Init_Timer1();
    Arme_Timer1();
    while((Flag_Timer1==0) && ( Flag_Buffer1==0));
    
    // test si reception de commande venant du terminal (UART1)
    if (Flag_Buffer1==1)
    {
       p= strstr(buffer1,"Msg=");  // p pointer result
       if ((p>0) && (strlen(buffer1)>6))
       {
        k=strlen(buffer1);
        if ((k>6) && (k<84))
         {
           UART1_Write_Text("\r\nhello, i get your Msg!\r\n");
           strcpy(txt,buffer1+4);
          }
       }  //p
       p= strstr(buffer1,"TEMP_ON");  // p pointer result
       if (p>0)
       {
        Drapeaux.Temper=1;
        k=strlen(buffer1);
        UART1_Write_CText("\r\nOK, Temper is ON!\r\n");
       } //p
       p= strstr(buffer1,"TEMP_OFF");  // p pointer result
       if (p>0)
       {
        Drapeaux.Temper=0;
        UART1_Write_CText("\r\nOK, Temper is OFF!\r\nRetour au display txt \r\n");
       } //p
       p= strstr(buffer1,"Speed=");  // p pointer result
       if (p>0)
       {
         k=strlen(buffer1);
         if(k>6)
         {
           #ifdef DEBUGGING
           // test si tous les digits sont des chiffres
          CRLF1();UART1_Write_Text(buffer1+6);CRLF1();
          #endif
          m=0;
          for (i=0;i<(k-6);i++)
          {
             if ((*(buffer1+6+i)>='0')&&(*(buffer1+6+i)<='9'))  m++;
          }
          if (m==(k-6))
          {
          n= atoi(buffer1+6);
          #ifdef DEBUGGING
            UART1_Write_CText("\r\n m= ");
            WordToStr(n,CRam1);
            UART1_Write_Text(CRam1);CRLF1();
          #endif
           if ((n>1)&&(n<512)) Speed=n;
           UART1_Write_CText("\r\nChange Speed To ");
           WordToStr(Speed,CRam1);
           UART1_Write_Text(CRam1);CRLF1();
          }
         }
         #ifdef DEBUGGING
          UART1_Write_CText("\r\n m= ");
          WordToStr(m,CRam1);
          UART1_Write_Text(CRam1);CRLF1();
         #endif
       } //p
       p= strstr(buffer1,"EEPROM=");  // p pointer result
       if (p>0)
       {
         k=strlen(buffer1);
         if((k>7)&&(k<10))
         {
          m=0;
          for (i=0;i<(k-7);i++)
          {
             if ((*(buffer1+7+i)>='0')&&(*(buffer1+7+i)<='9'))  m++;
          }
          if (m==(k-7))
          {
            n= atoi(buffer1+7);
        //  #ifdef DEBUGGING
            UART1_Write_CText("\r\n m= ");
            WordToStr(n,CRam1);
            UART1_Write_Text(CRam1);UART1_Write(TAB);
        //  #endif
           if ((n>=0)&&(n<16)) 
           {
           k=n<<6;
        //  #ifdef DEBUGGING
           UART1_Write_CText("  Eeprom Msg adresse ");
           WordToHex(k,CRam1);
           UART1_Write_Text(CRam1);CRLF1();
         //  #endif
            Read_Msg64_Eeprom(txt,k);
            }
          }
         }
       } //p
       
      RAZ_UART1();
     } // flag
   }
 }
 
 /*



Presentation :
 Mikroc 6.63 18F46K22
 Directory : C:_MikroC_MesProjets_MikroC_Max7219_4_matrice8x8
 Projet : 18F46K22_MAX7219_4x_Matrice8x8.mcppir
 Source : 18F46K22_test_Max71219_4xMatrice8x8_SOFT_SPI_161219.c
 Module Matrice 8x8 avec MAX7129
 Saisir un nouveau Msg avec le terminal via <Msg=xxxx>
 Mode Temperature avec <TEMP_ON> ou <TEMP_OFF>
Messages en EEPROM avec cde : <EEPROM=0> ..  15


Clock initiale in  =  8000 Khz
init ADC EA0
init SOFT SPI  RC3=Clk ,RC5=Dout  RC0=CS -> MAx7219:
Clear Matrice 2x 8x8
Init et test interrupt Timer1  8 x 125 msec soit 2 sec
$
#
Display <0123456789> sur matrices Leds
Display <J=   0  TAMB= 48.3 C> sur matrices Leds
J=  19 TAMB= 48.3C
Affiche Messages 0  15  stockes en EEPROM du PIC18F
Eeprom # 0000   Page Web : paulfjujo.free.fr :  Joyeux Noel 2016Et Bonne Anne
Eeprom # 0040   Pic18F46K22  MikroC Pro 6.63    16 Mesg en EEPROM de 64 caract
Eeprom # 0080   Jeux de car  ASCIIde  0  127   ABCDEFGHIJKLMNOPQRSTUVWXYZ abc
Eeprom # 00C0   efghijklmnopqrstuwxyz#$+-_[]&= vide
Eeprom # 0100   vid
Eeprom # 0140   Rie
Eeprom # 0180   vide
Eeprom # 01C0   Empt
Eeprom # 0200   Empt
Eeprom # 0240   Empty
Eeprom # 0280   Empty
Eeprom # 02C0   Empty
Eeprom # 0300   Empty
Eeprom # 0340   Empt
Eeprom # 0380   Empt
Message 8 : *JOYEUX NOEL*
~*~JOYEUX NOEL~*~
~*~JOYEUX NOEL~*~
~*~JOYEUX NOEL~*~
EEPROM=2

 m=     2         Eeprom Msg adresse 0080
Jeux de car  ASCIIde  0  127   ABCDEFGHIJKLMNOPQRSTUVWXYZ abc
TEMP_ON

OK, Temper is ON!
J=   4  T.Amb=45.0C
J=   5  T.Amb=44.9C
TEMP_OFF

OK, Temper is OFF!
Retour au display txt
Jeux de car  ASCIIde  0  127   ABCDEFGHIJKLMNOPQRSTUVWXYZ abc
Speed=8

Change Speed To     8
Jeux de car  ASCIIde  0  127   ABCDEFGHIJKLMNOPQRSTUVWXYZ abc
Msg=COUCOU C'est MOI

hello, i get your Msg!
COUCOU C'est MOI
COUCOU C'est MOI
COUCOU C'est MOI
Msg=Fin de Test

hello, i get your Msg!
Fin de Test
Fin de Test
TEMP_ON

OK, Temper is ON!
J=   3  T.Amb=45.0C
J=   4  T.Amb=44.9C
J=   5  T.Amb=44.9C
*************************************

0 1 mikroCPIC1618.exe -MSF -DBG -pP18F46K22 -RA -C -O11111014 -fo8 -N"C:\_MikroC\_MesProjets_MikroC\_Max7219_4_matrice8x8\18F46K22_MAX7219_4x_Mat_8x8_SPI1_Softw.mcppi" -EH"C:\_MikroC\_MesProjets_MikroC\_Max7219_4_matrice8x8\18F46K22_MAX7219_4x_Mat_8x8_SPI1_Softw_EEPROM.ihex" -SP"C:\_MikroC\mikroC PRO for PIC\Defs\" -SP"C:\_MikroC\mikroC PRO for PIC\uses\P18\" -SP"C:\_MikroC\_MesProjets_MikroC\_Max7219_4_matrice8x8\" -SP"C:\_MikroC\_MesProjets_MikroC\_Max7219_4_matrice8x8\" -IP"C:\_MikroC\_MesProjets_MikroC\_Max7219_4_matrice8x8\" "18F46K22_test_Max71219_4xMatrice8x8_SOFT_SPI_161220.c" "__Lib_Math.mcl" "__Lib_MathDouble.mcl" "__Lib_System.mcl" "__Lib_Delays.mcl" "__Lib_CType.mcl" "__Lib_CString.mcl" "__Lib_CStdlib.mcl" "__Lib_Conversions.mcl" "__Lib_SoftSPI.mcl" "__Lib_ADC_A_D.mcl" "__Lib_EEPROM_1024.mcl" "__Lib_I2C_c34d01.mcl" "__Lib_UART_c67d67.mcl"
0 1139 Available RAM: 3875 [bytes], Available ROM: 65536 [bytes]
0 122 Compilation Started P18F46K22.c
2781 123 Compiled Successfully P18F46K22.c
0 122 Compilation Started __Lib_Delays.c
172 123 Compiled Successfully __Lib_Delays.c
0 122 Compilation Started 18F46K22_test_Max71219_4xMatrice8x8_SOFT_SPI_161220.c
0 1004 interrupt handler (Interrupt_High at 0x0008) 18F46K22_test_Max71219_4xMatrice8x8_SOFT_SPI_161220.c
0 1004 interrupt handler (Interrupt_LOW at 0x0018) 18F46K22_test_Max71219_4xMatrice8x8_SOFT_SPI_161220.c
577 1509 Generated baud rate is 19231 bps (error = 0.16 percent) 18F46K22_test_Max71219_4xMatrice8x8_SOFT_SPI_161220.c
845 123 Compiled Successfully 18F46K22_test_Max71219_4xMatrice8x8_SOFT_SPI_161220.c
113 1164 Variable 'c1' has been eliminated by optimizer 18F46K22_test_Max71219_4xMatrice8x8_SOFT_SPI_161220.c
0 127 All files Compiled in 156 ms
0 1144 Used RAM (bytes): 582 (15%)  Free RAM (bytes): 3293 (85%) Used RAM (bytes): 582 (15%)  Free RAM (bytes): 3293 (85%)
0 1144 Used ROM (bytes): 13167 (20%)  Free ROM (bytes): 52369 (80%) Used ROM (bytes): 13167 (20%)  Free ROM (bytes): 52369 (80%)
0 125 Project Linked Successfully 18F46K22_MAX7219_4x_Mat_8x8_SPI1_Softw.mcppi
0 128 Linked in 78 ms
0 129 Project '18F46K22_MAX7219_4x_Mat_8x8_SPI1_Softw.mcppi' completed: 453 ms
0 103 Finished successfully: 20 dc. 2016, 18:05:48 18F46K22_MAX7219_4x_Mat_8x8_SPI1_Softw.mcppi


*/