 // datasheet MAX7219.pdf
 //file:///C:/_MikroC/_MesProjets_MikroC/_16F887_MAX7219-digits/Maxim%20MAX7219.html
 // rev 18-12-2016 paulfjujo
 
sfr extern  SPI_CS ;
extern unsigned char  Aff_buffer[];

#include "Fonte_Ascii_8x8.h"
//#include "CP850_modifie.h"


 void SPI_Write_To_4x7219(unsigned char adr, unsigned char d1, unsigned char d2,unsigned char d3, unsigned char d4);
 void Clear_Matrices(void) ;
 void Affiche_Char(unsigned char c, unsigned int v);
 void Init_Module_4_Max7129_8x8(void);
 void Affiche_Text_Matrice(unsigned char *p1, unsigned int V1);
 void Affiche_CText_Matrice(const unsigned char *p2, unsigned int V2);


#define REG_DECODE        0x09                        // "decode mode" register
#define REG_INTENSITY     0x0A                        // "intensity" register
#define REG_SCAN_LIMIT    0x0B                        // "scan limit" register
#define REG_SHUTDOWN      0x0C                        // "shutdown" register
#define REG_DISPLAY_TEST  0x0F                        // "display test" register
#define INTENSITY_MIN     0x00                        // minimum display intensity  1/32
#define INTENSITY_MAX     0x0F                        // maximum display intensity  31/32
#define INTENSITY_MOY     0x07                        // moyenne 15/32


 void Init_Module_4_Max7129_8x8()
 {
  SPI_CS = 1;
  SPI_Write_To_4x7219(REG_DECODE, 0x00, 0x00,0x00, 0x00); //pas de decodage - no decode
  SPI_Write_To_4x7219(REG_INTENSITY, 0x00,0x00,0x00,0x00); //intensit - intensity  minima
  //scan limit registre  digit 0  7 .. les colonnes de la matrice
  SPI_Write_To_4x7219(REG_SCAN_LIMIT , 0x07, 0x07,0x07,0x07);
  SPI_Write_To_4x7219(REG_SHUTDOWN, 0x01, 0x01, 0x01, 0x01); // normal operation
  SPI_Write_To_4x7219(0x0F, 0x00, 0x00, 0x00, 0x00); // pas de test - no test
  Delay_ms(10);
  Clear_Matrices() ;
  Delay_ms(100);
 }

#ifdef SOFTWARE_SPI1
 void SPI_Write_To_4x7219(unsigned char adr, unsigned char d1, unsigned char d2,unsigned char d3, unsigned char d4)
  {
    SPI_CS = 0;
    Soft_SPI_Write(adr);
    Soft_SPI_Write(d1);
    Soft_SPI_Write(adr);
    Soft_SPI_Write(d2);
    Soft_SPI_Write(adr);
    Soft_SPI_Write(d3);
    Soft_SPI_Write(adr);
    Soft_SPI_Write(d4);
    SPI_CS = 1;
}
#endif
#ifdef HARDWARE_SPI1
 void SPI_Write_To_4x7219(unsigned char adr, unsigned char d1, unsigned char d2,unsigned char d3, unsigned char d4)
  {
    SPI_CS = 0;
    SPI1_Write(adr);
    SPI1_Write(d1);
    SPI1_Write(adr);
    SPI1_Write(d2);
    SPI1_Write(adr);
    SPI1_Write(d3);
    SPI1_Write(adr);
    SPI1_Write(d4);
    SPI_CS = 1;
}
#endif

 void Clear_Matrices()
 {
    unsigned char i;
    for (i = 0; i < 8; i++)
     {
      SPI_Write_To_4x7219(i+1,0,0,0,0 ); // efface 4 afficheurs
    }

}


 void Affiche_Char(unsigned char c, unsigned int v)
  {
   unsigned int i,j,k;
   char n;
   k=c * 8;
   n=0;
    Aff_buffer[0]=font_8x8[c];
    for (j = 0; j < 8; j++)
    {
       for (i = 32; i > 0; i--)
         {
            Aff_buffer[i] = Aff_buffer[i-1];
        }
       Aff_buffer[0] =font_8x8[j + k];
        n = 0;
        for (i = 8; i > 0; i--)
        {
           SPI_Write_To_4x7219(i, Aff_buffer[n], Aff_buffer[n+8],Aff_buffer[n+16],Aff_buffer[n+24]);
            n++;
       }
     for(i=0;i<v;i++) Delay_ms(1);
    }
}


void Affiche_Text_Matrice(unsigned char *p1, unsigned int V1)
{
unsigned char c1;
    while (*(p1)>0)
     { c1=*(p1);
       Affiche_Char(c1, V1);
        p1++;
    }

}

void Affiche_CText_Matrice(const unsigned char *p2, unsigned int V2)
{
    while (*(p2)>0)
     {
       Affiche_Char(*(p2),V2);
        p2++;
    }
}